Qwt User's Guide: QwtCompass Class Reference

Qwt User's Guide 5.2.3

- Main Page
- Related Pages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions
QwtCompass Class Reference

`#include <qwt_compass.h>`

Inheritance diagram for QwtCompass:
[legend]

List of all members.

## Public Member Functions
| QwtCompass (QWidget *parent=NULL)
virtual | ~QwtCompass ()
const QMap< double, QString > & | labelMap () const
QMap< double, QString > & | labelMap ()
const QwtCompassRose * | rose () const
QwtCompassRose * | rose ()
void | setLabelMap (const QMap< double, QString > &map)
void | setRose (QwtCompassRose *rose)
Public Member Functions inherited from QwtDial
| QwtDial (QWidget *parent=NULL)
virtual | ~QwtDial ()
QRect | boundingRect () const
QRect | contentsRect () const
Direction | direction () const
Shadow | frameShadow () const
bool | hasVisibleBackground () const
int | lineWidth () const
double | maxScaleArc () const
virtual QSize | minimumSizeHint () const
double | minScaleArc () const
Mode | mode () const
const QwtDialNeedle * | needle () const
QwtDialNeedle * | needle ()
double | origin () const
virtual QRect | scaleContentsRect () const
QwtDialScaleDraw * | scaleDraw ()
const QwtDialScaleDraw * | scaleDraw () const
void | setDirection (Direction)
void | setFrameShadow (Shadow)
void | setLineWidth (int)
void | setMode (Mode)
virtual void | setNeedle (QwtDialNeedle *)
virtual void | setOrigin (double)
virtual void | setScale (int maxMajIntv, int maxMinIntv, double step=0.0)
void | setScaleArc (double min, double max)
virtual void | setScaleDraw (QwtDialScaleDraw *)
void | setScaleOptions (int)
void | setScaleTicks (int minLen, int medLen, int majLen, int penWidth=1)
virtual void | setWrapping (bool)
void | showBackground (bool)
virtual QSize | sizeHint () const
bool | wrapping () const
Public Member Functions inherited from QwtAbstractSlider
| QwtAbstractSlider (Qt::Orientation, QWidget *parent=NULL)
virtual | ~QwtAbstractSlider ()
bool | isReadOnly () const
bool | isValid () const
virtual double | mass () const
Qt::Orientation | orientation () const
virtual void | setMass (double val)
virtual void | setOrientation (Qt::Orientation o)
void | setTracking (bool enable)
void | setUpdateTime (int t)
void | setValid (bool valid)
void | stopMoving ()
Public Member Functions inherited from QwtDoubleRange
| QwtDoubleRange ()
virtual | ~QwtDoubleRange ()
virtual void | incPages (int)
double | maxValue () const
double | minValue () const
int | pageSize () const
bool | periodic () const
void | setPeriodic (bool tf)
void | setRange (double vmin, double vmax, double vstep=0.0, int pagesize=1)
void | setStep (double)
double | step () const
double | value () const

## Protected Member Functions
virtual void | drawRose (QPainter *, const QPoint &center, int radius, double north, QPalette::ColorGroup) const
virtual void | drawScaleContents (QPainter *, const QPoint &center, int radius) const
virtual void | keyPressEvent (QKeyEvent *)
virtual QwtText | scaleLabel (double value) const
Protected Member Functions inherited from QwtDial
virtual void | drawContents (QPainter *) const
virtual void | drawFocusIndicator (QPainter *) const
virtual void | drawFrame (QPainter *p)
virtual void | drawNeedle (QPainter *, const QPoint &, int radius, double direction, QPalette::ColorGroup) const
virtual void | drawScale (QPainter *, const QPoint &center, int radius, double origin, double arcMin, double arcMax) const
virtual void | getScrollMode (const QPoint &, int &scrollMode, int &direction)
virtual double | getValue (const QPoint &)
virtual void | paintEvent (QPaintEvent *)
virtual void | rangeChange ()
virtual void | resizeEvent (QResizeEvent *)
virtual void | updateMask ()
void | updateScale ()
virtual void | valueChange ()
Protected Member Functions inherited from QwtAbstractSlider
virtual void | mouseMoveEvent (QMouseEvent *e)
double | mouseOffset () const
virtual void | mousePressEvent (QMouseEvent *e)
virtual void | mouseReleaseEvent (QMouseEvent *e)
int | scrollMode () const
void | setMouseOffset (double)
virtual void | setPosition (const QPoint &)
virtual void | timerEvent (QTimerEvent *e)
virtual void | wheelEvent (QWheelEvent *e)
Protected Member Functions inherited from QwtDoubleRange
double | exactPrevValue () const
double | exactValue () const
double | prevValue () const
virtual void | stepChange ()

## Additional Inherited Members
Public Types inherited from QwtDial
enum | Direction { Clockwise, CounterClockwise }
enum | Mode { RotateNeedle, RotateScale }
enum | ScaleOptions { ScaleBackbone = 1, ScaleTicks = 2, ScaleLabel = 4 }
enum | Shadow { Plain = QFrame::Plain, Raised = QFrame::Raised, Sunken = QFrame::Sunken }
Public Types inherited from QwtAbstractSlider
enum | ScrollMode { ScrNone, ScrMouse, ScrTimer, ScrDirect, ScrPage }

## Detailed Description

A Compass Widget.

QwtCompass is a widget to display and enter directions. It consists of a scale, an optional needle and rose.

Note:
  The examples/dials example shows how to use QwtCompass.

## Constructor & Destructor Documentation

QwtCompass::QwtCompass | ( | QWidget * | parent = `NULL` | ) |
| explicit

Constructor.

Parameters:

  parent | Parent widget

Create a compass widget with a scale, no needle and no rose. The default origin is 270.0 with no valid value. It accepts mouse and keyboard inputs and has no step size. The default mode is QwtDial::RotateNeedle.

## Member Function Documentation

void QwtCompass::drawRose | ( | QPainter * | painter,
|  | const QPoint & | center,
|  | int | radius,
|  | double | north,
|  | QPalette::ColorGroup | cg
| ) |  | const
| protectedvirtual

Draw the compass rose

Parameters:

  painter | Painter
  center | Center of the compass
  radius | of the circle, where to paint the rose
  north | Direction pointing north, in degrees counter clockwise
  cg | Color group

void QwtCompass::drawScaleContents | ( | QPainter * | painter,
|  | const QPoint & | center,
|  | int | radius
| ) |  | const
| protectedvirtual

Draw the contents of the scale

Parameters:

  painter | Painter
  center | Center of the content circle
  radius | Radius of the content circle

Reimplemented from QwtDial.

void QwtCompass::keyPressEvent | ( | QKeyEvent * | kev | ) |
| protectedvirtual

Handles key events

Beside the keys described in QwtDial::keyPressEvent numbers from 1-9 (without 5) set the direction according to their position on the num pad.

See also:
  isReadOnly()

Reimplemented from QwtDial.

const QMap< double, QString > & QwtCompass::labelMap | ( |  | ) | const

Returns:
  map, mapping values to labels

See also:
  setLabelMap()

QMap< double, QString > & QwtCompass::labelMap | ( |  | ) |

Returns:
  map, mapping values to labels

See also:
  setLabelMap()

const QwtCompassRose * QwtCompass::rose | ( |  | ) | const

Returns:
  rose

See also:
  setRose()

QwtCompassRose * QwtCompass::rose | ( |  | ) |

Returns:
  rose

See also:
  setRose()

QwtText QwtCompass::scaleLabel | ( | double | value | ) | const
| protectedvirtual

Map a value to a corresponding label

Parameters:

  value | Value that will be mapped

Returns:
  Label, or QString::null

label() looks in a map for a corresponding label for value or return an null text.

See also:
  labelMap(), setLabelMap()

Reimplemented from QwtDial.

void QwtCompass::setLabelMap | ( | const QMap< double, QString > & | map | ) |

Set a map, mapping values to labels.

Parameters:

  map | value to label map

The values of the major ticks are found by looking into this map. The default map consists of the labels N, NE, E, SE, S, SW, W, NW.

Warning:
  The map will have no effect for values that are no major tick values. Major ticks can be changed by QwtScaleDraw::setScale

See also:
  labelMap(), scaleDraw(), setScale()

void QwtCompass::setRose | ( | QwtCompassRose * | rose | ) |

Set a rose for the compass

Parameters:

  rose | Compass rose

Warning:
  The rose will be deleted, when a different rose is set or in ~QwtCompass

See also:
  rose()